package fr.natan.addressmicroservice.exceptions_handler;

import fr.natan.addressmicroservice.exceptions.AddressAlreadyExistsException;
import fr.natan.addressmicroservice.exceptions.AddressNotFoundException;
import fr.natan.addressmicroservice.exceptions.AddressOneOrMoreFieldsEmptyException;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

@ControllerAdvice
public class AddressExceptionsHandler {

    @ExceptionHandler(value = AddressNotFoundException.class)
    private ResponseEntity<String> handleAddressNotFoundException(){
        return new ResponseEntity<>("Address not found exception",
                HttpStatus.NOT_FOUND);
    }

    @ExceptionHandler(value = AddressOneOrMoreFieldsEmptyException.class)
    private ResponseEntity<String> handleAddressOneOrMoreFieldsEmptyException(){
        return new ResponseEntity<>("Address, one or more fields empty exception",
                HttpStatus.NOT_ACCEPTABLE);
    }

    @ExceptionHandler(value = AddressAlreadyExistsException.class)
    private ResponseEntity<String> handleAddressAlreadyExistsException(){
        return new ResponseEntity<>("Address already exists exception",
                HttpStatus.NOT_ACCEPTABLE);
    }
}
