package fr.natan.addressmicroservice.service.contract;

import fr.natan.addressmicroservice.entity.Address;
import fr.natan.addressmicroservice.exceptions.AddressAlreadyExistsException;
import fr.natan.addressmicroservice.exceptions.AddressNotFoundException;
import fr.natan.addressmicroservice.exceptions.AddressOneOrMoreFieldsEmptyException;

import java.util.List;

public interface AddressContract {
    Address createAddress(Address address) throws AddressOneOrMoreFieldsEmptyException, AddressAlreadyExistsException;
    List<Address> getAllAddresses();
    Address getAddressByID(Long addressID) throws AddressNotFoundException;
    public List<Address> getAddressByNumHouseAndStreetNameAndPbAndCity(
            String numHouse, String streetName, String pb, String city);
    void deleteAddress(Long addressID) throws AddressNotFoundException;
    Address updateAddress(Long addressID, Address address) throws AddressNotFoundException;
}
