package fr.natan.companymicroservice.exceptions_handler;

import fr.natan.companymicroservice.exceptions.CompanyNameAlreadyExistsException;
import fr.natan.companymicroservice.exceptions.CompanyNameEmptyException;
import fr.natan.companymicroservice.exceptions.CompanyNotFoundException;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

@ControllerAdvice
public class CompanyExceptionsHandler {

    @ExceptionHandler(value = CompanyNameAlreadyExistsException.class)
    private ResponseEntity<String> handleCompanyNameAlreadyExistsException(){
        return new ResponseEntity<>("Company name already exists exception",
        HttpStatus.NOT_ACCEPTABLE);
    }

    @ExceptionHandler(value = CompanyNameEmptyException.class)
    private ResponseEntity<String> handleCompanyNameEmptyException(){
        return new ResponseEntity<>("Company name is empty exception",
                HttpStatus.NOT_ACCEPTABLE);
    }

    @ExceptionHandler(value = CompanyNotFoundException.class)
    private ResponseEntity<String> handleCompanyNotFoundException(){
        return new ResponseEntity<>("Company not found exception",
                HttpStatus.NOT_FOUND);
    }
}
