package fr.natan.companymicroservice.service.contract;

import fr.natan.companymicroservice.exceptions.CompanyNameEmptyException;
import fr.natan.companymicroservice.exceptions.CompanyNotFoundException;
import fr.natan.companymicroservice.model.entity.Company;
import fr.natan.companymicroservice.exceptions.CompanyNameAlreadyExistsException;

import java.util.List;

public interface CompanyContract {
    Company createCompany(Company company) throws CompanyNameAlreadyExistsException, CompanyNameEmptyException;
    Company getCompanyByName(String companyName);
    List<Company> getAllCompanies();
    Company getCompanyByID(Long companyID) throws CompanyNotFoundException;
    Company updateCompany(Long companyID, Company company) throws CompanyNotFoundException;
    void deleteCompany(Long companyID) throws CompanyNotFoundException;
}
