package fr.natan.employeemicroservice.entity;

import fr.natan.employeemicroservice.t_openFeign.address.Address;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;

@Entity
public class Employee {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long employeeID;
    private String firstname;
    private String lastname;
    private String email;
    private String createdDate;
    private String birthCountry;
    private Long addressID;
    @Transient
    private Address address;

    public Employee() {
    }

    public Employee(Long employeeID,
                    String firstname, String lastname,
                    String email, String createdDate,
                    String birthCountry, Long addressID,
                    Address address) {
        this.employeeID = employeeID;
        this.firstname = firstname;
        this.lastname = lastname;
        this.email = email;
        this.createdDate = createdDate;
        this.birthCountry = birthCountry;
        this.addressID = addressID;
        this.address = address;
    }

    public Long getEmployeeID() {
        return employeeID;
    }

    public void setEmployeeID(Long employeeID) {
        this.employeeID = employeeID;
    }

    public String getFirstname() {
        return firstname;
    }

    public void setFirstname(String firstname) {
        this.firstname = firstname;
    }

    public String getLastname() {
        return lastname;
    }

    public void setLastname(String lastname) {
        this.lastname = lastname;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(String createdDate) {
        this.createdDate = createdDate;
    }

    public String getBirthCountry() {
        return birthCountry;
    }

    public void setBirthCountry(String birthCountry) {
        this.birthCountry = birthCountry;
    }

    public Long getAddressID() {
        return addressID;
    }

    public void setAddressID(Long addressID) {
        this.addressID = addressID;
    }

    public Address getAddress() {
        return address;
    }

    public void setAddress(Address address) {
        this.address = address;
    }
}
