package fr.natan.employeemicroservice.exceptions_handler;

import fr.natan.employeemicroservice.exceptions.AddressNotFoundException;
import fr.natan.employeemicroservice.exceptions.EmployeeAlreadyExistsException;
import fr.natan.employeemicroservice.exceptions.EmployeeNotFoundException;
import fr.natan.employeemicroservice.exceptions.EmployeeOneOrMoreFieldsEmptyException;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

@ControllerAdvice
public class EmployeeExceptionHandler {

    @ExceptionHandler(value = AddressNotFoundException.class)
    private ResponseEntity<String> handlerAddressNotFoundException(){
        return new ResponseEntity<>("Address to affect employee not found exception",
                HttpStatus.NOT_FOUND);
    }

    @ExceptionHandler(value = EmployeeAlreadyExistsException.class)
    private ResponseEntity<String> handleEmployeeAlreadyExistsException(){
        return new ResponseEntity<>("Employee with same firstname and lastname already exists exception",
                HttpStatus.NOT_ACCEPTABLE);
    }

    @ExceptionHandler(value = EmployeeNotFoundException.class)
    private ResponseEntity<String> handleEmployeeNotFoundException(){
        return new ResponseEntity<>("Employee not found exception",
                HttpStatus.NOT_FOUND);
    }

    @ExceptionHandler(value = EmployeeOneOrMoreFieldsEmptyException.class)
    private ResponseEntity<String> handleEmployeeOneOrMoreFieldsEmptyException(){
        return new ResponseEntity<>("Employee, one or more fields empty exception",
                HttpStatus.NOT_ACCEPTABLE);
    }
}
