package fr.natan.employeemicroservice.service.contract;

import fr.natan.employeemicroservice.entity.Employee;
import fr.natan.employeemicroservice.exceptions.AddressNotFoundException;
import fr.natan.employeemicroservice.exceptions.EmployeeAlreadyExistsException;
import fr.natan.employeemicroservice.exceptions.EmployeeNotFoundException;
import fr.natan.employeemicroservice.exceptions.EmployeeOneOrMoreFieldsEmptyException;

import java.util.List;

public interface EmployeeContract {
    Employee createEmployee(Employee user, Long addressID) throws EmployeeAlreadyExistsException, EmployeeOneOrMoreFieldsEmptyException, AddressNotFoundException;
    Employee getEmployeeByName(String firstname, String lastname);
    List<Employee> getAllEmployees();
    Employee getEmployeeByID(Long employeeID) throws EmployeeNotFoundException;
    List<Employee> getEmployeesLivingAtAddressID(Long addressID) throws AddressNotFoundException;
    Employee updateEmployee(Long employeeID, Employee employee) throws EmployeeNotFoundException, AddressNotFoundException;
    void deleteEmployee(Long employeeID) throws EmployeeNotFoundException;
}
