package fr.natan.projectmicroservice.exceptions_handler;

import fr.natan.projectmicroservice.exceptions.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

@ControllerAdvice
public class ProjectExceptionsHandler {

    @ExceptionHandler(value = CompanyNotFoundException.class)
    private ResponseEntity<String> handleCompanyNotFoundException(){
        return new ResponseEntity<>("Company for this project not found exception",
                HttpStatus.NOT_ACCEPTABLE);
    }

    @ExceptionHandler(value = EmployeeNotFoundException.class)
    private ResponseEntity<String> handleEmployeeNotFoundException(){
        return new ResponseEntity<>("Employee for this project not found exception",
                HttpStatus.NOT_ACCEPTABLE);
    }
    @ExceptionHandler(value = ProjectAlreadyExistsException.class)
    private ResponseEntity<String> handleProjectAlreadyExistsException(){
        return new ResponseEntity<>("Project already exists exception",
                HttpStatus.NOT_ACCEPTABLE);
    }
    @ExceptionHandler(value = ProjectDescriptionShortException.class)
    private ResponseEntity<String> handleProjectDescriptionShortException(){
        return new ResponseEntity<>("Project description is short exception",
                HttpStatus.NOT_ACCEPTABLE);
    }
    @ExceptionHandler(value = ProjectNotFoundException.class)
    private ResponseEntity<String> handleProjectNotFoundException(){
        return new ResponseEntity<>("Project not found exception",
                HttpStatus.NOT_FOUND);
    }
    @ExceptionHandler(value = ProjectOneOrMoreFieldsInvalidException.class)
    private ResponseEntity<String> handleProjectOneOrMoreFieldsInvalidException(){
        return new ResponseEntity<>("Project, one or more fields empty exception",
                HttpStatus.NOT_ACCEPTABLE);
    }
}
