package fr.natan.projectmicroservice.model.entity;

import fr.natan.projectmicroservice.model.enumType.ProjectPriority;
import fr.natan.projectmicroservice.model.enumType.ProjectProgress;
import fr.natan.projectmicroservice.t_openFeign.company_model.model.Company;
import fr.natan.projectmicroservice.t_openFeign.employee_model.Employee;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;

@Entity
@Data @AllArgsConstructor @NoArgsConstructor
public class Project {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long projectID;
    private String projectName;
    @Enumerated(value = EnumType.STRING)
    private ProjectPriority projectPriority;
    private String createdDate;
    private String description;
    @Enumerated(value = EnumType.STRING)
    private ProjectProgress projectProgress;
    private Long employeeID;
    @Transient
    private Employee employee;
    private Long companyID;
    @Transient
    private Company company;
}
