package fr.natan.projectmicroservice.repository;

import fr.natan.projectmicroservice.exceptions.CompanyNotFoundException;
import fr.natan.projectmicroservice.exceptions.EmployeeNotFoundException;
import fr.natan.projectmicroservice.model.entity.Project;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.rest.core.annotation.RepositoryRestResource;

import java.util.List;

@RepositoryRestResource
public interface ProjectRepository extends JpaRepository<Project, Long> {
    Project findByProjectName(String projectName);
    List<Project> findByEmployeeID(Long employeeID) throws EmployeeNotFoundException;
    List<Project> findByCompanyID(Long companyID) throws CompanyNotFoundException;
    List<Project> findByEmployeeIDAndCompanyID(Long employeeID, Long companyID) throws EmployeeNotFoundException,
            CompanyNotFoundException;
}
