package fr.natan.projectmicroservice.service.contract;

import fr.natan.projectmicroservice.exceptions.*;
import fr.natan.projectmicroservice.model.entity.Project;

import java.util.List;

public interface ProjectContract {
    Project createProject(Project project, Long employeeID, Long companyI)
            throws ProjectAlreadyExistsException, ProjectOneOrMoreFieldsInvalidException, EmployeeNotFoundException,
            CompanyNotFoundException, ProjectDescriptionShortException;
    Project getProjectByName(String projectName);
    List<Project> getAllProjects();
    Project getProjectByID(Long projectID) throws ProjectNotFoundException;
    Project updateProject(Long ProjectID, Project project) throws ProjectNotFoundException, EmployeeNotFoundException,
            CompanyNotFoundException, ProjectOneOrMoreFieldsInvalidException, ProjectDescriptionShortException;
    void deleteProject(Long projectID) throws ProjectNotFoundException;
    List<Project> getProjectsAffectedToEmployee(Long employeeID) throws EmployeeNotFoundException;
    List<Project> getProjectsAffectedToCompany(Long companyID) throws CompanyNotFoundException;

    List<Project> getProjectsAffectedToAEmployeeInACompany(Long employeeID, Long companyID) throws
            EmployeeNotFoundException, CompanyNotFoundException;
}
