package fr.natan.springcloudgatewayservice;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.ReactiveDiscoveryClient;
import org.springframework.cloud.gateway.discovery.DiscoveryClientRouteDefinitionLocator;
import org.springframework.cloud.gateway.discovery.DiscoveryLocatorProperties;
import org.springframework.context.annotation.Bean;

@SpringBootApplication
public class SpringCloudGatewayServiceApplication {

	public static void main(String[] args) {
		SpringApplication.run(SpringCloudGatewayServiceApplication.class, args);
	}

//	@Bean
//	RouteLocator staticRoute(RouteLocatorBuilder routeLocatorBuilder){
//		return routeLocatorBuilder.routes()
//				.route(route->route.path("/addresses/**").uri("http://localhost:8081"))
//				.route(route->route.path("/employees/**").uri("http://localhost:8082"))
//				.route(route -> route.path("/companies/**").uri("http://localhost:8083"))
//				.route(route -> route.path("/projects/**").uri("http://localhost:8084"))
//				.build();
//	}

//	@Bean
//	RouteLocator staticRoutes(RouteLocatorBuilder routeLocatorBuilder){
//		return routeLocatorBuilder.routes()
//				.route(route->route.path("/addresses/**").uri("lb://ADDRESS-SERVICE"))
//				.route(route -> route.path("/employees/**").uri("lb://PERSON-SERVICE"))
//				.route(route -> route.path("/companies/**").uri("lb://COMPANY-SERVICE"))
//				.route(route -> route.path("/projects/**").uri("lb://PROJECT-SERVICE"))
//				.build();
//	}

	@Bean
	DiscoveryClientRouteDefinitionLocator discoveryClientRouteDefinitionLocator(ReactiveDiscoveryClient rdc, DiscoveryLocatorProperties dlp){
		return new DiscoveryClientRouteDefinitionLocator(rdc, dlp);
	}

}
